Package icyllis.modernui.util

# Class SparseBooleanArray

java.lang.Object
icyllis.modernui.util.SparseBooleanArray

All Implemented Interfaces:
  `Cloneable`

public class SparseBooleanArray extends Object implements Cloneable
SparseBooleanArrays map integers to booleans. Unlike a normal array of booleans there can be gaps in the indices. It is intended to be more memory efficient than using a HashMap to map Integers to Booleans, both because it avoids auto-boxing keys and values and its data structure doesn't rely on an extra entry object for each mapping.

Note that this container keeps its mappings in an array data structure, using a binary search to find keys. The implementation is not intended to be appropriate for data structures that may contain large numbers of items. It is generally slower than a traditional HashMap, since lookups require a binary search and adds and removes require inserting and deleting entries in the array. For containers holding up to hundreds of items, the performance difference is not significant, less than 50%.

It is possible to iterate over the items in this container using `keyAt(int)` and `valueAt(int)`. Iterating over the keys using `keyAt(int)` with ascending values of the index will return the keys in ascending order, or the values corresponding to the keys in ascending order in the case of `valueAt(int)`.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SparseBooleanArray()`
  Creates a new SparseBooleanArray containing no mappings.
  `SparseBooleanArray(int initialCapacity)`
  Creates a new SparseBooleanArray containing no mappings that will not require any additional memory allocation to store the specified number of mappings.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `append(int key, boolean value)`
  Puts a key/value pair into the array, optimizing for the case where the key is greater than all existing keys in the array.
  `void`
  `clear()`
  Removes all key-value mappings from this SparseBooleanArray.
  `SparseBooleanArray`
  `clone()`
  `void`
  `delete(int key)`
  Removes the mapping from the specified key, if there was any.
  `boolean`
  `equals(Object that)`
  `boolean`
  `get(int key)`
  Gets the boolean mapped from the specified key, or `false` if no such mapping has been made.
  `boolean`
  `get(int key, boolean defaultValue)`
  Gets the boolean mapped from the specified key, or the specified value if no such mapping has been made.
  `int`
  `hashCode()`
  `int`
  `indexOfKey(int key)`
  Returns the index for which `keyAt(int)` would return the specified key, or a negative number if the specified key is not mapped.
  `int`
  `indexOfValue(boolean value)`
  Returns an index for which `valueAt(int)` would return the specified key, or a negative number if no keys map to the specified value.
  `int`
  `keyAt(int index)`
  Given an index in the range `0...size()-1`, returns the key from the `index`th key-value mapping that this SparseBooleanArray stores.
  `void`
  `put(int key, boolean value)`
  Adds a mapping from the specified key to the specified value, replacing the previous mapping from the specified key if there was one.
  `void`
  `removeAt(int index)`
  Removes the mapping at the specified index.
  `void`
  `setKeyAt(int index, int key)`
  `void`
  `setValueAt(int index, boolean value)`
  Directly set the value at a particular index.
  `int`
  `size()`
  Returns the number of key-value mappings that this SparseBooleanArray currently stores.
  `String`
  `toString()`
  `boolean`
  `valueAt(int index)`
  Given an index in the range `0...size()-1`, returns the value from the `index`th key-value mapping that this SparseBooleanArray stores.

  ### Methods inherited from class java.lang.Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### SparseBooleanArray

    public SparseBooleanArray()
    Creates a new SparseBooleanArray containing no mappings.

  - ### SparseBooleanArray

    public SparseBooleanArray(int initialCapacity)
    Creates a new SparseBooleanArray containing no mappings that will not require any additional memory allocation to store the specified number of mappings. If you supply an initial capacity of 0, the sparse array will be initialized with a light-weight representation not requiring any additional array allocations.

- ## Method Details

  - ### get

    public boolean get(int key)
    Gets the boolean mapped from the specified key, or `false` if no such mapping has been made.

  - ### get

    public boolean get(int key, boolean defaultValue)
    Gets the boolean mapped from the specified key, or the specified value if no such mapping has been made.

  - ### delete

    public void delete(int key)
    Removes the mapping from the specified key, if there was any.

  - ### removeAt

    public void removeAt(int index)
    Removes the mapping at the specified index.

  - ### put

    public void put(int key, boolean value)
    Adds a mapping from the specified key to the specified value, replacing the previous mapping from the specified key if there was one.

  - ### size

    public int size()
    Returns the number of key-value mappings that this SparseBooleanArray currently stores.

  - ### keyAt

    public int keyAt(int index)
    Given an index in the range `0...size()-1`, returns the key from the `index`th key-value mapping that this SparseBooleanArray stores.

    The keys corresponding to indices in ascending order are guaranteed to be in ascending order, e.g., `keyAt(0)` will return the smallest key and `keyAt(size()-1)` will return the largest key.

  - ### valueAt

    public boolean valueAt(int index)
    Given an index in the range `0...size()-1`, returns the value from the `index`th key-value mapping that this SparseBooleanArray stores.

    The values corresponding to indices in ascending order are guaranteed to be associated with keys in ascending order, e.g., `valueAt(0)` will return the value associated with the smallest key and `valueAt(size()-1)` will return the value associated with the largest key.

  - ### setValueAt

    public void setValueAt(int index, boolean value)
    Directly set the value at a particular index.

  - ### setKeyAt

    public void setKeyAt(int index, int key)

  - ### indexOfKey

    public int indexOfKey(int key)
    Returns the index for which `keyAt(int)` would return the specified key, or a negative number if the specified key is not mapped.

  - ### indexOfValue

    public int indexOfValue(boolean value)
    Returns an index for which `valueAt(int)` would return the specified key, or a negative number if no keys map to the specified value. Beware that this is a linear search, unlike lookups by key, and that multiple keys can map to the same value and this will find only one of them.

  - ### clear

    public void clear()
    Removes all key-value mappings from this SparseBooleanArray.

  - ### append

    public void append(int key, boolean value)
    Puts a key/value pair into the array, optimizing for the case where the key is greater than all existing keys in the array.

  - ### hashCode

    public int hashCode()
    Overrides:
      `hashCode` in class `Object`

  - ### equals

    public boolean equals(@Nullable Object that)
    Overrides:
      `equals` in class `Object`

  - ### toString

    public String toString()

    This implementation composes a string by iterating over its mappings.

    Overrides:
      `toString` in class `Object`

  - ### clone

    public SparseBooleanArray clone()
    Overrides:
      `clone` in class `Object`